module Glib
		def self.isodd?(input)
				return input % 2 != 0
		end


		def self.iseven?(input)
				return input % 2 == 0
		end


		def self.greatest(array)
				if not array.kind_of?(Array) then raise TypeError end
				greatest_index = 0
				for i in 0..array.length - 1
						if array[i] > array[greatest_index]
								greatest_index = i
						end
				end
				return greatest_index
		end


		def self.smallest(array)
				if not array.kind_of?(Array) then raise TypeError end
				smallest_index = 0
				for i in 1..array.length - 1
						if array[i] < array[smallest_index]
								smallest_index = i
						end
				end
				return smallest_index
		end

		def self.readconfig(path, separator = ": ")
			if not File.exist?(path) then raise NoMethodError end
			lines = File.readlines(path)
			config = {}
			lines.each do |line|
				key, value = line.split(separator)
				config = config.merge({key => value})
			end
			return config
		end

		def self.tableprint(array)
			if not array.kind_of?(Array) then raise TypeError end
			long = 0
			for i in 0..array.length - 1
				for j in 0..array[i].length - 1
					if array[i][j].to_s.length > long
						long = array[i][j].to_s.length
					end
				end
			end

			for i in 0..array.length - 1
				for j in 0..array[i].length - 1
					spaces = " "
					for k in 1..long - array[i][j].to_s.length
						spaces = spaces + " "
					end
					print array[i][j].to_s + spaces
				end
				puts ""
			end
		end

		def self.uniform(array)
			if not array.kind_of?(Array) then raise TypeError end
			check = array.length
			for i in 1..array.length - 1
				if array[i] == array[0]
					check-=1
				end
			end
			return check == 0
		end

		def self.encode(pwd)
		  key = ""

		  for i in 0...pwd.length
		    key = key + pwd[i].ord.to_s
		  end

		  while key.to_s.length < 30
		    key = key + key.split("").shuffle.join
		  end

		  while key.to_s.length > 30
		    key1 = key.to_s.slice(30..-1)
		    key = key.to_s.slice(0..29).to_i + key1.to_i
		  end

		  return key
		end
end
